/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.yslifes.ic;

import com.pi4j.io.gpio.GpioController;
import com.pi4j.io.gpio.GpioFactory;
import com.pi4j.io.gpio.GpioPinDigitalOutput;
import com.pi4j.io.gpio.Pin;
import com.pi4j.io.gpio.PinState;
import com.pi4j.wiringpi.Shift;
import java.lang.Thread;





/**
 *
 * @author Eric
 */
public class IC74CH595 {
    private GpioPinDigitalOutput mr ;
    private GpioPinDigitalOutput shcp ;
    private GpioPinDigitalOutput stcp;
    private GpioPinDigitalOutput ds;
    private final GpioController gpio = GpioFactory.getInstance();;
    private long ms ;
    private int data;
    public IC74CH595(Pin dspin,Pin mrpin,Pin stcppin,Pin shcppin)
    {
        
        
        mr = gpio.provisionDigitalOutputPin(mrpin,
                        PinState.HIGH);
        ds = gpio.provisionDigitalOutputPin(dspin,
                        PinState.LOW);
        shcp = gpio.provisionDigitalOutputPin(shcppin,
                        PinState.LOW);
        stcp = gpio.provisionDigitalOutputPin(stcppin,
                        PinState.LOW);
        ms = 300;
    }
    
    
    public void setLED(int i)
    {
        data = i;
        stcp.setState(PinState.LOW);
        Shift.shiftOut((byte)ds.getPin().getAddress(), (byte)shcp.getPin().getAddress(), (byte)Shift.MSBFIRST, (byte)(data>> 8));
        Shift.shiftOut((byte) ds.getPin().getAddress(), (byte) shcp.getPin().getAddress(), (byte) Shift.MSBFIRST, (byte) data);
        stcp.setState(PinState.HIGH);
        delay();
    }
    public void shutdown()
    {
        gpio.shutdown();
        gpio.unprovisionPin(mr);
        gpio.unprovisionPin(ds);
        gpio.unprovisionPin(shcp);
        gpio.unprovisionPin(stcp);
    }
    public  void clear()
    {
        mr.setState(PinState.LOW);
        mr.setState(PinState.HIGH);
    }
      private  void delay() {
        try {
            Thread.sleep(ms);
       } catch (InterruptedException e) {
            System.out.println(e.toString());
        }
    }
}
